/*
 * PM - 2017
 * Proiect Necula Ovidiu
 */

#include <avr/io.h>
#include <util/delay.h>


void exemplu(void) {
	
	int a = 0;
	int b = 3;
	char c = 0;
	/* Setez pinul PB7 si PA7 ca intrare. */
	DDRA &= ~(1 << PA7);
	DDRB &= ~(1 << PB7);
	/* Activez rezistenta de pull-up pentru pinul PB7 si PA7 . */
	PORTA |= (1 << PA7);
	PORTB |= (1 << PB7);

	/* Setez pinii PC0-PC6 si PA6 ca iesire. */
	DDRC |= (1 << PC0);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC2);
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC4);
	DDRC |= (1 << PC5);
	DDRC |= (1 << PC6);
	DDRA |= (1 << PA6);
	/* Sting LED-ul. */
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);
	PORTC &= ~(1 << PC5);
	PORTC &= ~(1 << PC6);
	PORTA &= ~(1 << PA6);
	while (1) {
		/* Daca rezervorul contine destula apa. */
		if ((PINB & (1 << PB7)) == 0)
		{
			c = 0;
			a = 0;
			b = 3;
			PORTC |= (1 << PC0);
			PORTC |= (1 << PC1);
			PORTC |= (1 << PC2);
			PORTC |= (1 << PC3);
			PORTC |= (1 << PC4);
			PORTC |= (1 << PC5);
			PORTC |= (1 << PC6);
		}
		else
		{
			/* Jocul ledurilor in cazul in care nu este destula apa*/
			c = 1;
			if (a == 0 || b == 0)
			{
				PORTC |= (1 << PC6);
				PORTC &= ~(1 << PC0);
				_delay_ms(100);
			}
			if (a == 1 || b == 1)
			{

				PORTC |= (1 << PC0);
				PORTC &= ~(1 << PC1);
				_delay_ms(100);
			}
			if (a == 2 || b == 2)
			{

				PORTC |= (1 << PC1);
				PORTC &= ~(1 << PC2);
				_delay_ms(100);
			}
			if (a == 3 || b == 3)
			{

				PORTC |= (1 << PC2);
				PORTC &= ~(1 << PC3);
				_delay_ms(100);
			}
			if (a == 4 || b == 4)
			{
				PORTC |= (1 << PC3);
				PORTC &= ~(1 << PC4);
				_delay_ms(100);
			}
			if (a == 5 || b == 5)
			{
				PORTC |= (1 << PC4);
				PORTC &= ~(1 << PC5);
				_delay_ms(100);
			}
			if (a == 6 || b == 6)
			{
				PORTC |= (1 << PC5);
				PORTC &= ~(1 << PC6);
				_delay_ms(100);
			}	
			a++;
			a = a % 7;
			b++;
			b = b % 7;
		}
		/* Daca planta este uda*/
		if ((PINA & (1 << PA7)) == 0)
		{
			PORTA &=~ (1 << PA6);
			
			
		}
		else
		{
			/*Daca este destula apa in rezervor*/
			if (c==0)
			{
				PORTA |= (1 << PA6);
			}
		}
	}
}

/*
 * Aprinde LED-urile legate la portul C in functie de secventele alese.
 * Secventa va fi selectata la apasarea butonului PB2 sau PD6.
 */


int main(void) {
	exemplu();

	return 0;
}
